tvbrowser.core.tvdataservice

## Interface TvDataServiceProxy

- All Superinterfaces:
    ButtonActionIf, ContextMenuIf, InfoIf
  All Known Implementing Classes:
    AbstractTvDataServiceProxy, DefaultTvDataServiceProxy

      public interface TvDataServiceProxy
      extends ContextMenuIf, ButtonActionIf, InfoIf

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `TvDataServiceProxy.Comparator` comparator for data service proxies (sorting alphabetically by name)

  - ### Field Summary

    - ### Fields inherited from interface devplugin.ContextMenuIf

      `ACTIONKEY_KEYBOARD_EVENT`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Channel[]` | `checkForAvailableChannels(ChannelGroup group, ProgressMonitor monitor)`
    `Channel[]` | `checkForAvailableChannels(ProgressMonitor monitor)` Some TvDataServices may need to connect to the Internet to know their channels.
    `ChannelGroup[]` | `checkForAvailableGroups(ProgressMonitor monitor)`
    `SettingsPanel` | `getAuthenticationPanel()` If the download of the TV data needs authentication create a panel that contains information about the authentification and the authentication form.
    `Channel[]` | `getAvailableChannels()` Gets the list of the channels that are available for the given channel group.
    `Channel[]` | `getAvailableChannels(ChannelGroup group)`
    `ChannelGroup[]` | `getAvailableGroups()`
    `Channel[]` | `getChannelsForTvBrowserStart()`
    `java.lang.String` | `getDataServicePackageName()`
    `java.lang.String` | `getId()` Gets the ID of this ContextMenuIf.
    `PluginInfo` | `getInfo()` Gets information about this TvDataService
    `java.awt.Frame` | `getParentFrame()` Gets the parent frame.
    `SettingsPanel` | `getSettingsPanel()`
    `void` | `handleTvBrowserStartFinished()` This method is called when the TV-Browser start is complete.
    `boolean` | `hasSettingsPanel()` A TvDataService can have a settings panel within the settings dialog.
    `void` | `loadSettings(java.util.Properties settings)` Called by the host-application during start-up.
    `void` | `setParent(java.awt.Frame parent)` Called by the host-application to provide the parent frame.
    `void` | `setWorkingDirectory(java.io.File dataDir)` This method is called by the host application to set the working folder.
    `java.util.Properties` | `storeSettings()` Called by the host-application during shut-down.
    `boolean` | `supportsAutoUpdate()` Gets if the data service supports auto upate of data.
    `boolean` | `supportsDynamicChannelGroups()`
    `boolean` | `supportsDynamicChannelList()`
    `void` | `updateTvData(TvDataUpdateManager updateManager, Channel[] channelArr, Date startDate, int dateCount, ProgressMonitor monitor)` Updates the TV listings provided by this data service.

    - ### Methods inherited from interface devplugin.ContextMenuIf

      `getContextMenuActions`

    - ### Methods inherited from interface tvbrowser.core.plugin.ButtonActionIf

      `getButtonAction, getButtonActionDescription`

    - ### Methods inherited from interface devplugin.InfoIf

      `getPluginCategory`

- - ### Method Detail

    - #### setWorkingDirectory

          void setWorkingDirectory(java.io.File dataDir)

      This method is called by the host application to set the working folder. If required, TvDataService implementations should store their data within this 'dataDir' directory
      Parameters:
        `dataDir` -

    - #### getAvailableGroups

          ChannelGroup[] getAvailableGroups()

      Returns:
        an array of the available channel groups.

    - #### updateTvData

          void updateTvData(TvDataUpdateManager updateManager,
                          Channel[] channelArr,
                          Date startDate,
                          int dateCount,
                          ProgressMonitor monitor)
                            throws TvBrowserException

      Updates the TV listings provided by this data service.
      Throws:
        `TvBrowserException`

    - #### loadSettings

          void loadSettings(java.util.Properties settings)

      Called by the host-application during start-up. Implement this method to load your dataservices settings from the file system.

    - #### storeSettings

          java.util.Properties storeSettings()

      Called by the host-application during shut-down. Implements this method to store your dataservices settings to the file system.

    - #### hasSettingsPanel

          boolean hasSettingsPanel()

      A TvDataService can have a settings panel within the settings dialog. If the hasSettingsPanel() method returns false, the getSettingsPanel() method is never called.
      Returns:
        true, if the settings panel feature is used by this TvDataService

    - #### getSettingsPanel

          SettingsPanel getSettingsPanel()

      Returns:
        the SettingsPanel of this TvDataService

    - #### getAvailableChannels

          Channel[] getAvailableChannels()

      Gets the list of the channels that are available for the given channel group.

    - #### checkForAvailableChannels

          Channel[] checkForAvailableChannels(ProgressMonitor monitor)
                                              throws TvBrowserException

      Some TvDataServices may need to connect to the Internet to know their channels. If `supportsDynamicChannelList()` returns true, this method is called to check for available channels.
      Parameters:
        `monitor` -
      Returns:
        the list of available channels
      Throws:
        `TvBrowserException`

    - #### checkForAvailableGroups

          ChannelGroup[] checkForAvailableGroups(ProgressMonitor monitor)
                                                 throws TvBrowserException

      Throws:
        `TvBrowserException`

    - #### checkForAvailableChannels

          Channel[] checkForAvailableChannels(ChannelGroup group,
                                            ProgressMonitor monitor)
                                              throws TvBrowserException

      Throws:
        `TvBrowserException`

    - #### getAvailableChannels

          Channel[] getAvailableChannels(ChannelGroup group)

    - #### getChannelsForTvBrowserStart

          Channel[] getChannelsForTvBrowserStart()

      Returns:
        The channels that have to be loaded on TVB start.
      Since:
        2.3

    - #### supportsDynamicChannelList

          boolean supportsDynamicChannelList()

      Returns:
        true, if this TvDataService can dynamically load other channels

    - #### supportsDynamicChannelGroups

          boolean supportsDynamicChannelGroups()

    - #### getInfo

          PluginInfo getInfo()

      Gets information about this TvDataService
      Specified by:
        `getInfo` in interface `InfoIf`
      Returns:
        The plugin info.

    - #### getId

          java.lang.String getId()

      Description copied from interface: `ContextMenuIf`
      Gets the ID of this ContextMenuIf.
      Specified by:
        `getId` in interface `ButtonActionIf`
      Specified by:
        `getId` in interface `ContextMenuIf`
      Specified by:
        `getId` in interface `InfoIf`
      Returns:
        a unique id to identify this TvDataService

    - #### setParent

          void setParent(java.awt.Frame parent)

      Called by the host-application to provide the parent frame.
      Parameters:
        `parent` - The parent frame.
      Since:
        2.7

    - #### getParentFrame

          java.awt.Frame getParentFrame()

      Gets the parent frame.

      The parent frame may be used for showing dialogs.

      Returns:
        The parent frame.
      Since:
        2.7

    - #### handleTvBrowserStartFinished

          void handleTvBrowserStartFinished()

      This method is called when the TV-Browser start is complete.
      Since:
        2.7

    - #### supportsAutoUpdate

          boolean supportsAutoUpdate()

      Gets if the data service supports auto upate of data.
      Returns:
        `True` if the data service supports the auto update, `false` otherwise.
      Since:
        2.7

    - #### getDataServicePackageName

          java.lang.String getDataServicePackageName()

      Returns:
        package name of data service
      Since:
        3.0

    - #### getAuthenticationPanel

          SettingsPanel getAuthenticationPanel()

      If the download of the TV data needs authentication create a panel that contains information about the authentification and the authentication form.

      Returns:
        The panel with the authentication settings.
      Since:
        3.0.2

TV-Browser 3.4.3, Copyright (C) 2004-2008 TV-Browser Team (dev@tvbrowser.org)